<?php
/*--------------------------------------------------------
# BT Collection - Joomla! Template
# -------------------------------------------------------
# For Joomla! 2.5
# Copyright (C) 2012 Bonusthemes.com. All Rights Reserved.
# @license Copyrighted Commercial Software
# Demo: http://www.bonusthemes.com/demo/?template=collection
# Website: http://www.bonusthemes.com
# Support: support@bonusthemes.com
------------------------------------------------------- */

defined( '_JEXEC' ) or die( 'Restricted access' );

class btTemplateHelper
{	
	// DISPLAY (enable=1, disable=0)

	// outer_left, btlogo
	var $display_outer_left = '';
	var $display_btlogo = '';
	var $display_left_one = '';
	
	// logo, left
	var $display_logo = '';
	var $display_left = '';
	var $display_left_two = '';

	// toolbar, menu, pathway
	var $display_toolbar = '';
	var $display_menu = '';
	var $display_pathway = '';

	// main
	var $display_newsflash = '';
	var $display_search = '';
	var $display_news1 = '';
	var $display_news2 = '';
	var $display_news3 = '';
	var $display_mainbody = '';
	var $display_notice1 = '';
	var $display_notice2 = '';
	var $display_notice3 = '';
	var $display_banner = '';

	// right
	var $display_right = '';
	
	// bottom
	var $display_bottom1 = '';
	var $display_bottom2 = '';
	
	// footer
	var $display_footer1 = '';
	var $display_footer2 = '';
	var $display_footer3 = '';
	var $display_footer4 = '';
	var $display_footer5 = '';
	var $display_footer6 = '';

	// go top
	var $display_gotop = '';
	
	// WIDTHS
	var $full_width = '';
	var $main_right = 0;
	var $left_main = 0;
	var $left_main_right = 0;
	var $main = 0;

	// outer
	var $bt_main_outer_width = 0;

	// right
	var $right_width = '';

	// news width
	var $news1_width = '';
	var $news2_width = '';
	var $news3_width = '';
	
	// notice width
	var $notice1_width = '';
	var $notice2_width = '';
	var $notice3_width = '';

	// bottom width
	var $bottom1_width = '';
	var $bottom2_width = '';

	// footer
	var $footer1_width = '';
	var $footer2_width = '';
	var $footer3_width = '';
	var $footer4_width = '';
	var $footer6_width = '';
	var $btlogo_width = '';
	
	// template layout
	var $display_mainbody_on_frontpage = '';

	// MODULES

	// outer_left, btlogo
	var $bt_outer_left = '';
	var $bt_btlogo = '';
	
	// logo, left
	var $bt_logo = '';
	var $bt_system_logo = '';
	var $bt_left = '';

	// toolbar, menu, pathway
	var $bt_toolbar = '';
	var $bt_menu = '';
	var $bt_pathway = '';

	// main
	var $bt_newsflash = '';
	var $bt_search = '';
	var $bt_news1 = '';
	var $bt_news2 = '';
	var $bt_news3 = '';
	var $bt_mainbody = '';
	var $bt_notice1 = '';
	var $bt_notice2 = '';
	var $bt_notice3 = '';
	var $bt_banner = '';

	// right
	var $bt_right = '';
	
	// bottom
	var $bt_bottom1 = '';
	var $bt_bottom2 = '';
	
	// footer
	var $bt_footer1 = '';
	var $bt_footer2 = '';
	var $bt_footer3 = '';
	var $bt_footer4 = '';
	var $bt_footer5 = '';
	var $bt_footer6 = '';

	// go top
	var $bt_gotop = '';
	
	// template variables
	var $host = '';
	var $app = '';
	var $document = '';
	var $template_name = '';
	var $tmpl_params = '';
	var $skin = '';
	var $menu = '';
	
	// cookie
	var $bt_cookie_menu = '';

	// Constructor
	function __construct()
	{	
		// get jimport
		jimport( 'joomla.application.module.helper' );
		jimport('joomla.filesystem.file');
		jimport('joomla.environment.uri' );
		
		// default vars
		$this->host = JURI::root();
		$this->app = JFactory::getApplication();
		$this->document =& JFactory::getDocument();		
		$this->template_name = (JVERSION < '1.6') ? $this->app->getTemplate(true) : $this->app->getTemplate();
		
		// get template params
		if (JVERSION < '1.6') {
			// joomla 1.5
			$this->tmpl_params = new JParameter(JFile::read(JPATH_BASE.DS.'templates'.DS.$this->template_name.DS.'params.ini'));		
		}else{
			// joomla 1.6
			$this->tmpl_params = $this->app->getTemplate(true)->params;
		}
		
		// get current skin (from template parameters)
		$this->skin = $this->tmpl_params->get('skin');
		
		// set skin via cookies
		$this->setSkin();

		// get current menu (from template parameters)
		if (JRequest::getVar('skin') != '') {
			$this->skin = JRequest::getVar('skin');
		}else if (isset($_COOKIE["bt_cookie_skin"])){
			$this->skin = $_COOKIE["bt_cookie_skin"];
		}else{
			$this->skin = $this->tmpl_params->get('skin');
		}
		
		// set menu via cookies
		$this->setMenu();
		
		// get current menu (from template parameters)
		if (JRequest::getVar('menu') != '') {
			$this->menu = JRequest::getVar('menu');
		}else if (isset($_COOKIE["bt_cookie_menu"])){
			$this->menu = $_COOKIE["bt_cookie_menu"];
		}else{
			$this->menu = $this->tmpl_params->get('menu');
		}

		// get current tlayout (from template parameters)
		if (JRequest::getVar('tlayout') != '') {
			$this->tlayout = JRequest::getVar('tlayout');
		}else{
			$this->tlayout = $this->tmpl_params->get('tlayout');
		}

		// get template layout params
		$this->display_mainbody_on_frontpage = $this->tmpl_params->get('display_mainbody_on_frontpage');
		
		// call js files
		$this->getJSFiles();

		// call css files
		$this->getCSSFiles();
		
		// call config function
		$this->getConfig();
		
		// call modules function
		$this->getModules();
	}	

	// Set menu via cookies (for quickstart templates)
	function setMenu()
	{
		if (JRequest::getVar('menu') != '')
		{	
			setcookie("bt_cookie_menu", JRequest::getVar('menu'), time()+3600);
			return true;
		}
		return false;
	}

	// Set skin via cookies (for quickstart templates)
	function setSkin()
	{
		if (JRequest::getVar('skin') != '')
		{	
			setcookie("bt_cookie_skin", JRequest::getVar('skin'), time()+3600);
			return true;
		}
		return false;
	}

	// Check if modules are enabled, and return 1, or return 0 if is disabled
	function getConfig()
	{

		// outer_left, btlogo
		$this->display_outer_left = count(JModuleHelper::getModules('outer_left'));
		$this->display_btlogo = $this->tmpl_params->get('display_btlogo');
		$this->display_left_one = ($this->display_outer_left || $this->display_btlogo) ? 1 : 0;
	
		// logo, left
		$this->display_logo = count(JModuleHelper::getModules('logo')); //1;
		$this->display_left = count(JModuleHelper::getModules('left'));
		$this->display_left_two = ($this->display_logo || $this->display_left) ? 1 : 0;
		
		// toolbar, menu, pathway
		$this->display_toolbar = count(JModuleHelper::getModules('toolbar'));
		$this->display_menu = count(JModuleHelper::getModules('menu'));
		$this->display_pathway = count(JModuleHelper::getModules('pathway'));
	
		// main
		$this->display_newsflash = count(JModuleHelper::getModules('newsflash'));
		$this->display_search = count(JModuleHelper::getModules('search'));
		$this->display_news1 = count(JModuleHelper::getModules('news1'));
		$this->display_news2 = count(JModuleHelper::getModules('news2'));
		$this->display_news3 = count(JModuleHelper::getModules('news3'));
		$this->display_mainbody = $this->display_mainbody_on_frontpage;
		$this->display_notice1 = count(JModuleHelper::getModules('notice1'));
		$this->display_notice2 = count(JModuleHelper::getModules('notice2'));
		$this->display_notice3 = count(JModuleHelper::getModules('notice3'));
		$this->display_banner = count(JModuleHelper::getModules('banner'));
	
		// right
		$this->display_right = count(JModuleHelper::getModules('right'));
		
		// bottom
		$this->display_bottom1 = count(JModuleHelper::getModules('bottom1'));
		$this->display_bottom2 = count(JModuleHelper::getModules('bottom2'));
		
		// footer
		$this->display_footer1 = count(JModuleHelper::getModules('footer1'));
		$this->display_footer2 = count(JModuleHelper::getModules('footer2'));
		$this->display_footer3 = count(JModuleHelper::getModules('footer3'));
		$this->display_footer4 = count(JModuleHelper::getModules('footer4'));
		$this->display_footer5 = count(JModuleHelper::getModules('footer5'));
		$this->display_footer6 = count(JModuleHelper::getModules('footer6'));

		// go top
		$this->display_gotop = $this->tmpl_params->get('display_gotop');

		// TEMPLATE LAYOUT
		switch ($this->tlayout){
			case "left_main":
				$this->left_main = 1;
			break;
			case "main":
				$this->main = 1;
			break;
		}
				
		// Only Main (without left column)
		if ($this->main){
			$this->display_outer_left = 0;
			$this->display_left_two = 0;
		}
		
		// Left + Main
		if ($this->left_main){
			$this->display_left_cols = ($this->display_outer_left || $this->display_left_two) ? 1 : 0;
		}
		
		// WIDTHS
		$prefix = 'px';// or %
		$this->full_width = $this->tmpl_params->get('full_width');
		
		// LEFT OUTER
		$this->left_outer_width = $this->tmpl_params->get('left_outer_width');

		// LEFT
		$this->left_width = $this->tmpl_params->get('left_width'); // only the value (ex. 240)

		// LEFT
		$this->right_width = $this->tmpl_params->get('right_width'); // only the value (ex. 240)

		// MAIN
		// calculate widths
		$this->left_outer_width = ($this->display_outer_left) ? $this->left_outer_width : 0;
		$this->left_width = ($this->display_left_two) ? $this->left_width : 0;
		$this->right_width = ($this->display_right) ? $this->right_width : 0;

		// total
		$this->bt_main_outer_width = $this->full_width - ($this->left_outer_width + $this->left_width);

		// ALL Modules Widths

		// news width
		$this->news1_width = (int)$this->tmpl_params->get('news1_width');
		$this->news2_width = (int)$this->tmpl_params->get('news2_width');
		$this->news3_width = (int)$this->tmpl_params->get('news3_width');
		
		// notice width
		$this->notice1_width = (int)$this->tmpl_params->get('notice1_width');
		$this->notice2_width = (int)$this->tmpl_params->get('notice2_width');
		$this->notice3_width = (int)$this->tmpl_params->get('notice3_width');
	
		// bottom width
		$this->bottom1_width = (int)$this->tmpl_params->get('bottom1_width');
		$this->bottom2_width = (int)$this->tmpl_params->get('bottom2_width');
	
		// footer
		$this->footer1_width = (int)$this->tmpl_params->get('footer1_width');
		$this->footer2_width = (int)$this->tmpl_params->get('footer2_width');
		$this->footer3_width = (int)$this->tmpl_params->get('footer3_width');
		$this->footer4_width = (int)$this->tmpl_params->get('footer4_width');
		$this->footer6_width = (int)$this->tmpl_params->get('footer6_width');
		$this->btlogo_width = (int)$this->tmpl_params->get('btlogo_width');
				
		return $this;
	}
	
	// Get the code from all modules
	function getModules()
	{		
		// GENERAL
		
		// logo for error/offline page
		$logo_system_image = '<img src="'.$this->host.'templates/'.$this->template_name.'/images/'.$this->skin.'/layout/system_logo.png" alt="logo" />';
		$this->bt_system_logo = '<div id="bt_img"><a href="'.$this->host.'">'.$logo_system_image.'</a></div>';

		// outer_left, btlogo
		$this->bt_outer_left = '<jdoc:include type="modules" name="outer_left" style="BTxhtml" />';
		$this->bt_btlogo = '<div class="bt_powered_by_logo bt_fade_img"><a href="http://www.bonusthemes.com/" title="" target="_blank"></a></div>';
		
		// logo, left
		$this->bt_logo = '<jdoc:include type="modules" name="logo" style="BTxhtml" />';
		
		$this->bt_left = '<jdoc:include type="modules" name="left" style="BTxhtml" />';
	
		// toolbar, menu, pathway
		$this->bt_toolbar = '<jdoc:include type="modules" name="toolbar" style="BTxhtml" />';
		$this->bt_menu = '<jdoc:include type="modules" name="menu" style="BTxhtml" />';
		$this->bt_pathway = '<jdoc:include type="modules" name="pathway" style="BTxhtml" />';
	
		// main
		$this->bt_newsflash = '<jdoc:include type="modules" name="newsflash" style="BTxhtml" />';
		$this->bt_search = '<jdoc:include type="modules" name="search" style="BTxhtml" />';
		$this->bt_news1 = '<jdoc:include type="modules" name="news1" style="BTxhtml" />';
		$this->bt_news2 = '<jdoc:include type="modules" name="news2" style="BTxhtml" />';
		$this->bt_news3 = '<jdoc:include type="modules" name="news3" style="BTxhtml" />';
		$this->bt_mainbody = ($this->display_mainbody_on_frontpage == 0 && (JRequest::getVar('view') == 'featured' || JRequest::getVar('view') == 'article')) ? '<jdoc:include type="message" />' : '<jdoc:include type="message" /><jdoc:include type="component" />';
		$this->bt_notice1 = '<jdoc:include type="modules" name="notice1" style="BTxhtml" />';
		$this->bt_notice2 = '<jdoc:include type="modules" name="notice2" style="BTxhtml" />';
		$this->bt_notice3 = '<jdoc:include type="modules" name="notice3" style="BTxhtml" />';
		$this->bt_banner = '<jdoc:include type="modules" name="banner" style="BTxhtml" />';
	
		// right
		$this->bt_right = '<jdoc:include type="modules" name="right" style="BTxhtml" />';
		
		// bottom
		$this->bt_bottom1 = '<jdoc:include type="modules" name="bottom1" style="BTxhtml" />';
		$this->bt_bottom2 = '<jdoc:include type="modules" name="bottom2" style="BTxhtml" />';
		
		// footer
		$this->bt_footer1 = '<jdoc:include type="modules" name="footer1" style="BTxhtml" />';
		$this->bt_footer2 = '<jdoc:include type="modules" name="footer2" style="BTxhtml" />';
		$this->bt_footer3 = '<jdoc:include type="modules" name="footer3" style="BTxhtml" />';
		$this->bt_footer4 = '<jdoc:include type="modules" name="footer4" style="BTxhtml" />';
		$this->bt_footer5 = '<jdoc:include type="modules" name="footer5" style="BTxhtml" />';
		$this->bt_footer6 = '<jdoc:include type="modules" name="footer6" style="BTxhtml" />';
	
		// go top
		$this->bt_gotop = '<div id="bt_gotop_message" class="bt_go_top_button_img"><a href="#bttop"></a></div>';
				
		return $this;
	}
	
	function getPosition($div_name = '', $pos_names = array(), $div_width = '', $style = 'horizontal', $margin_top = '10', $margin_right = '10', $margin_bottom = '10', $margin_left = '10', $padding_top = '10', $padding_right = '10', $padding_bottom = '10', $padding_left = '10')
	{
		$html = '';

		$bt_div_name = ($div_name == '') ? '' : ' id="bt_'.$div_name.'_div';
							
		// Positions Names 
		$published_positions = array();
		$i = 1;
		foreach ($pos_names as $pos_name => $pos_width){
			$bt_name = ($pos_name == '') ? '' : ' '.'id="bt_'.$pos_name.'"';
			if ($this->{'display_'.$pos_name}){
				$published_positions[] = $pos_name;
			}
		$i++;
		}
		$published_positions_count = count($published_positions);
		
		// Division of module positions
		if ($published_positions_count > 0 && $style == 'horizontal'){
			if ($this->getPrefix($div_width) == 'px'){
				$inner_div_width = $div_width / $published_positions_count;
			}else{
				$inner_div_width = 100 / $published_positions_count;
			}
		}else{
			$inner_div_width = $div_width;
		}
				
		// Check if module is published
		if ($published_positions_count > 0){
			// print outer div
			$html .= ' <!-- '.strtoupper($div_name).' -->'."\n";

			// remove padding and margin from given width
			//$div_width = $div_width - ($margin_right + $margin_left + $padding_left + $padding_right);
		
			$html .= ' <div'.$bt_div_name.'" style="width: '.$div_width.'px;">'."\n";
			
			// Published module positions without width
			$empty_pos_widths = array();
			$i=1;
			foreach ($pos_names as $pos_name => $pos_width) {
				if ($pos_width == ''){
					if ($this->{'display_'.$pos_name}){
						$empty_pos_widths[] = $i;
					}
				}
			$i++;
			}
			$empty_pos_widths = count($empty_pos_widths);
			
			
			// Published module positions with width
			$no_display_width = array();
			foreach ($pos_names as $pos_name => $pos_width) {
				// Calculate unpublished module position with width
				if (!$this->{'display_'.$pos_name} && $pos_width != ''){
				 $no_display_width[] = $pos_width;
				}
			}
			$no_display_width = array_sum($no_display_width);

			// print inner divs
			$i = 1 ;
			$num = 1; // o arithmos twn published modules
			foreach ($pos_names as $pos_name => $pos_width) {
				
			$default_pos_width = $pos_width;

			// Calculate empty pos width - Check empty pos and divide them from div_width and after divide theme with num of empty modules
			if ($pos_width == ''){
				$pos_width = array_sum($pos_names);
				$pos_width = $div_width - $pos_width;
				$pos_width = $pos_width + $no_display_width;
				
				if ($empty_pos_widths > 0){
					$pos_width = ($pos_width / $empty_pos_widths);
				}else{
					$pos_width = $pos_width;
				}
			}
			
			// control bt_name
			$bt_name = ($pos_name == '') ? '' : ' class="bt_'.$pos_name.'"';
			$bt_sub_name = ($pos_name == '') ? '' : ' class="bt_sub_'.$pos_name.'"';

			// control float
			$float = ($style == 'horizontal') ? 'float: left; ' : '';
			
			// remove padding and margin from given width
			$pos_width = $pos_width - ($margin_right + $margin_left + $padding_left + $padding_right);
			$div_width = $div_width - ($margin_right + $margin_left + $padding_left + $padding_right);
			// control width
			$width = ($style == 'horizontal') ? 'width: '.$pos_width.'px;' : 'width: '.$div_width.'px;';

			// control margin, padding
			$margin = ($margin != '') ? $margin : 0;
			$padding = ($padding != '') ? $padding : 0;

			// control
			if ($this->{'display_'.$pos_name})
			{
				$html .= ' <div'.$bt_name.' style="'.$float.$width.' margin: '.$margin_top.'px '.$margin_right.'px '.$margin_bottom.'px '.$margin_left.'px; padding: '.$padding_top.'px '.$padding_right.'px '.$padding_bottom.'px '.$padding_left.'px;">'."\n";

				$html .= '<div'.$bt_sub_name.'>'."\n";

				$html .= ''.$this->{'bt_'.$pos_name}."\n";
				
				$html .= '</div>'."\n";
				$html .= ' </div>'."\n";
			$num++;
			}
			$i++;
			}
			
			// end outer div
			$html .= ' </div>'."\n";
		}
		
		return $html;
	}

	// call all js files will need for bt templates
	function getJSFiles()
	{
		// jquery
		//$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/jquery.min.js'); // default (for slide show, go top, fade image effect) ONLY IF YOU ARE NOT USE VIRTUEMART
		$this->document->addScript('//ajax.googleapis.com/ajax/libs/jquery/1.6.4/jquery.min.js');
		$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/jquery.cookie.js'); // (for css ajax switcher)

		// menu
		if ($this->menu != "css"){
			$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/drop_down.js');
		}
		
		// gotop
		$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/bt_gotop.js');

		// other effects
		$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/bt_fade_img.js'); // Fade image effect
		$this->document->addScript('templates/'.$this->template_name.'/helpers/assets/js/bt_popup.js'); // Fade popup (login, register form)
	}

	// call all css files will need for bt templates
	function getCSSFiles()
	{	
		$is_ie_9 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 9') !== false) ? 1 : 0;
		$ie = (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false) && $is_ie_9 != 1) ? 'ie' : '';
		$this->menu = ($this->menu == "drop_down") ? 'css' : $this->menu; 
		$this->document->addStyleSheet('templates/'.$this->template_name.'/css/menu/'.$this->menu.'.css');	
		
		if ($is_ie_9 != 1 && $ie != '') {
			$this->document->addStyleSheet('templates/'.$this->template_name.'/css/'.$ie.'.css');	
		}
	}

	function getPrefix($width)
	{
		if (strchr($width,"px") == 'px'){
			$prefix = 'px';
		}else if (strchr($width,"%") == '%'){
			$prefix = '%';
		}else{
			$prefix = '';
		}
		
		return $prefix;
	}

}
?>